<?php
// $Id: FeedsSyndicationParser.inc,v 1.4 2009/10/20 20:59:04 alexb Exp $

/**
 * Class definition for Common Syndication Parser.
 *
 * Parses RSS and Atom feeds.
 */
class FeedsSyndicationParser extends FeedsParser {

  /**
   * Parses a raw string and returns a Feed object from it.
   */
  public function parse(FeedsFetcherResult $fetcherResult, FeedsSource $source) {
    if ($fetcherResult->type == 'text/filepath') {
      $string = file_get_contents($fetcherResult->value);
    }
    else {
      $string = $fetcherResult->value;
    }
    feeds_include_library('common_syndication_parser.inc', 'common_syndication_parser');
    return new FeedsParserResult(common_syndication_parser_parse($string), 'syndication');
  }

  /**
   * Return mapping sources.
   *
   * At a future point, we could expose data type information here,
   * storage systems like Data module could use this information to store
   * parsed data automatically in fields with a correct field type.
   */
  public function getMappingSources() {
    return array(
      'title' => t('Title'),
      'description' => t('Description'),
      'author' => t('Author'),
      'timestamp' => t('Published date'),
      'url' => t('Item URL (link)'),
      'guid' => t('Item GUID'),
      'tags' => t('Categories'),
     );
  }
}